/* -*- Mode: IDL; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/*
 *  Copyright (C) 2008 OMC Denmark ApS.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef F2T_ITABLEDATA_DEF
#define F2T_ITABLEDATA_DEF

#pragma prefix "omc.brutus"

#include "types.idl"
#include "IMAPITable.idl"

module BRUTUS {

        interface ITableData : IUnknown {
		BRESULT HrGetView(in SSortOrderSet lpSSortOrderSet,
				  out IMAPITable lppMAPITable);

		BRESULT HrModifyRow(in SRow lpSRow);

		BRESULT HrDeleteRow(in SPropValue lpSPropValue);

		BRESULT HrQueryRow(in SPropValue lpSPropValue,
				   out SRow lppSRow,
				   inout unsigned long lpuliRow); // if !0 ==> Information is returned 

		BRESULT HrEnumRow(in unsigned long ulRowNumber,
				  out SRow lppSRow);

		BRESULT HrNotify(in BDEFINE ulFlags,
				 in seq_SPropValue lpSPropValue);

		BRESULT HrInsertRow(in unsigned long uliRow,
				    in SRow lpSRow);

		BRESULT HrModifyRows(in BDEFINE ulFlags,
				     in SRowSet lpSRowSet);

		BRESULT HrDeleteRows(in BDEFINE ulFlags,
				     in SRowSet lprowsetToDelete,
				     out unsigned long cRowsDeleted);
	};

}; // End of module BRUTUS


#endif
